/*
 Ev.prg
 Testbestand voor interne event systeem.
 Geschreven door Arno Tolmeijer
 Copyright AToll Software, (c) 1997.
*/

#include "Box.ch"

#include "..\App.ch"

/***
***/
PROCEDURE Main
LOCAL nCount := 0
LOCAL bHandler := { |nRow, nCol| nRow := ROW(), nCol := COL(),;
                                 DISPBEGIN(),;
                                 DevPos( 10, 10 ),;
                                 DevOut( NTrim( ++nCount ) ),;
                                 DevPos( nRow, nCol ),;
                                 DISPEND() }
LOCAL bHandler2 := { |nRow, nCol| nRow := ROW(), nCol := COL(),;
                                 DISPBEGIN(),;
                                 DevPos(  0, MAXCOL() - 10 ),;
                                 DevOut( TIME() ),;
                                 DevPos( nRow, nCol ),;
                                 DISPEND() }
LOCAL bHandler3 := { || MyHandler() }

// Het is ook mogelijk de naam van een procedure door te geven als event
// handler.
LOCAL cHandler  := "MyHandler"

LOCAL nKey
LOCAL cOldColor := SETCOLOR( "W+/W,GR+/BG,W,W,W+/BG" )
LOCAL cString   := ""


SETBLINK( .F. )
CLS
@  1, 0 TO  1, MAXCOL() COLOR "GR+/W"
@ 23, 0 TO 23, MAXCOL() COLOR "GR+/W"
@00 "Events die dwars door ons programma heen loopt."

SETCOLOR( "B/W" )
@ MAXROW(), 0 SAY "F1=SetEvent() F2=SetReentrant() F3=Block:teller F4=Block:klok F5,F6=Vertraging"

// Installeer de achtergrond event handler.
BEGIN SEQUENCE

   WHILE ( nKey := INKEY() ) <> K_ESC

      DO CASE
      CASE nKey == K_F1
         SetEvent( !SetEvent() )    // Zet event handler processing aan/uit

      CASE nKey == K_F2
         SetReentrant( !SetReentrant() )

      CASE nKey == K_F3
         IF !EvhSet( bHandler )
            BREAK
         ENDIF

      CASE nKey == K_F4
         IF !EvhSet( bHandler2 )
            BREAK
         ENDIF

      CASE nKey == K_F5
         IF !EvhSet( bHandler3 )
            BREAK
         ENDIF

      CASE nKey == K_F6
         IF !EvhSet( cHandler )
            BREAK
         ENDIF

      OTHERWISE
         IF nKey == K_BS
            cString := LEFT( cString, LEN( cString ) - 1 )
         ELSEIF nKey >= 32
            cString += CHR( nKey )
            cString := RIGHT( cString, 30 )
         ENDIF

         DISPBEGIN()
         @ 15, 20 CLEAR TO 15, 50
         @ 15, 20 SAY cString
         DISPEND()

      ENDCASE

      ShowStatus()
   ENDDO

   // Netjes afsluiten
   EvhClear()

RECOVER
   ALERT( "Fout: event handler kan niet worden genstalleerd" )

ENDSEQUENCE

@ MAXROW(),  0
@ MAXROW(), 35 SAY "Bye, bye!"
INKEY( 2 )

SETBLINK( .T. )
SETCOLOR( cOldColor )
CLS

RETURN


/***
 Deze event handler blijt twee seconden lang de rest van het systeem bezet
 houden.
***/
PROCEDURE MyHandler
LOCAL nTime := SECONDS()
LOCAL nRow  := ROW()
LOCAL nCol  := COL()
LOCAL nPos

#define N_DELAY   2        // Vertraging

nTime := SECONDS()
@ 5, 30
@ 5, 30 SAY "Resterend aantal seconden: "

nPos := COL()

WHILE SECONDS() - nTime < 2
   DISPBEGIN()
   @ 5, nPos SAY NTrim( nTime + 2 - SECONDS() )
   DISPEND()
ENDDO

DEVPOS( nRow, nCol )

RETURN


PROCEDURE ShowStatus

@ 2, 0, 8, 25 BOX B_DOUBLE

@ 3, 1 SAY "In handler: " + IF( EvInHandler(), "Ja ", "nee" )
@ 4, 1 SAY "Reentrant : " + IF( SetReentrant(), "Ja ", "nee" )

RETURN
