* Screensaver is not accurate. I need a function to find out how long
* ago a key or mouse event took place. How writes me?

* BGE_Seconds() has been replaced with BGE_DSeconds(). It returns the number
* of seconds since 01/01/1000. This is to avoid the midnight-syndrome.
* On purpose I deleted BGE_Seconds() so you will find the error soon.

* BGEVENTS is very fast. It may influence the speed of a FOR/NEXT loop.
* IN that case use BACKGROUND EVENTS INTERVAL <nInterval> to slow down
* BGEVENTS. Set it to .5 or even 1 if you don't use a clock on the screen.

* Clipper Includes
#include "inkey.ch"
#command	DEFAULT <p> TO <val> [,<pn> TO <valn> ] ;
		=> ;
		<p> = iif( <p> = NIL, <val>, <p> ) ;
		[;<pn> = iif( <pn> = NIL, <valn>, <pn> ) ]

#include "bgevents.ch"

Static aBooks[0]

Function Test
  Local cTekst := space(30)
  Local getlist[0]
  Local nKey := 0
  Local bKey
  Local oEvent
  Local aTest
  @ 0,0 clear


  @ 1,0, maxrow(), maxcol() box "Ŀ"
  @ 1,1 say Padc(" Demo Background events v5.0a", maxcol()-1) color "W/BR"

  /*
  * Event system definitions
  */

  If .F.  // set to .T. to test the myinkey() simulation
     // See Testsituation 2, later in this file.
     BGE_IDLEFUNC( {|b| Inkey_OnIdle( b ) } )
  Endif

//  BACKGROUND EVENTS STOP

//  background events debug off         // uncomment when using debugger

  SetReEntrant(.T.)      // set .F. when using debugger an AT_OnIdle()

  BGE_bRESTATE( {|| DISPRE() } )

  BACKGROUND EVENTS AUTOACTIVATE
//  BACKGROUND EVENTS INTERVAL 1
  BACKGROUND EVENTS EXECUTE ALL

  /*
  * Event definitions
  */
  Define backgroundevent Action Timer()  name "Timer" on activate acttimer()
//  Define backgroundevent Action Timer2()  name "Timer2" on activate acttimer2()

  Define backgroundevent Action DIRECTTONE()   name "directtone" DIRECT Interval 10

  Define backgroundevent Action ScrSaver()   name "screensaver"

  Define backgroundevent Action Clock(1)    interval .05
  Define backgroundevent Action Clock(2)    interval .05 Name "Klok2" ;
                         ON DEACTIVATE Clock(2, "R/W")  
  Define backgroundevent Action Clock(3)       interval .05 Name "Klok3" ;
                         ON DEACTIVATE Clock(3, "R/W")  
  Define backgroundevent Action Clock(4)    interval .05 Name "Klok4" ;
                         ON DEACTIVATE Clock(4, "R/W")

  Define backgroundevent Action StartTyping()  interval .05 name "Typing"
  Define backgroundevent Action SHOWSTOPDEMO() NAME "SHOWSTOP"
  Define backgroundevent Action STOPDEMO()  interval 44  // stop after 44 seconden

//  DEFINE BGEVENT ACTION BGE_CLEAR() interval 10
  Define backgroundevent oEvent ;
         Action Laptimer() ;
         NAME "LAPTIMER" ;
         INACTIVE ;
         ON DeActivate Lapwhiten(4)

  Define BGEVENT ACTION getme(2) name getme interval 5
  Define BGEVENT ACTION getme(3) name getme interval 5

  DEFINE BGEVENT ACTION bge_DEACT("Klok4") interval 1
  DEFINE BGEVENT ACTION bge_ACT("Klok4")   interval 1

  /*
  * Simulation of adding and deletion
  */
  * 'Books' with time-titles are added to a static array
  * With a low rate (interval 2) books are deleted
  * If the number of books is higher than 5 books are deleted at a higher rate
  * Interval .2
  * As soon as the number of books is 1, the low rate is reinstalled.

  Define backgroundevent Action AddBooks() interval 1 name "Addbooks"
  Define backgroundevent Action ShowBooks() on activate showinit() 
  Define backgroundevent Action KillBooks() interval 2  Name "Killbooks"

//  BACKGROUND EVENTS STart

  @ maxrow(),1 say pad("Esc-Exit  F4-Stop Event System  F5-Start Event System F6-Clock 4 On/Off", maxcol()-1) color "N/W"

  /*
  * Key definitions
  */
  setkey( K_F4, {|| BGE_STOP() } )
  setkey( K_F5, {|| BGE_START() } )
  setkey( K_F6, {|| IF( BGE_EVENT( "Klok4")[ BGE_LACTIVE],  BGE_DEACT( "Klok4" ), BGE_ACT( "Klok4") ) } )

  @ 5,2, 14,45 box space(9) color "N/W"  
  @ 5,2 say  "DEFINE ;" color "N/W"
  @ 6,2 say  "  [ BACKGROUNDEVENT][ BGEVENT ] [<oEvent>];" color "N/W"
  @ 7,2 say  "  [ NAME     <cResname>  ] ;" color "N/W"
  @ 8,2 say  "  [ ACTION   <uAction >  ] ;" color "N/W"
  @ 9,2 say  "  [ ON ACTIVATE  <uOnActication > ] ;" color "N/W"
  @ 10,2 say "  [ ON DEACTIVATE  <uDeAction >  ] ;" color "N/W"
  @ 11,2 say "  [ INTERVAL <nInterval> ] ;" color "N/W"
  @ 12,2 say "  [ <Direct : DIRECT >] ;" color "N/W"
  @ 13,2 say "  [ <Inactive : INACTIVE >] ;" color "N/W"
  @ 14,2 say "  [ WHEN     <bWhen>     ] ;" color "N/W"
  @ 15,2 say "  [ <Once: ONCE>         ] ;" color "N/W"

  // Testsituation 2
  If .f.  // this is the way how to include it in your function Myinkey()
     // Function MyInkey()
     Do while nKey != 27
        nKey := inkey()
        Eval( InkeyEvents() )
     Enddo
     return nKey

  Else
     @ 3,2 say "Text : " get cTekst valid .f.
     read
  Endif

  @ 0,0 clear
Return nil

Function ShowInit()
  Local col     := col()
  Local row     := row()

  @ 11,60 clear to 21,75
  @ 14,60       to 21,75
  @ 11,60,14,75 box "Ŀó "
  @ 11,63 say "Simulation" color "W+/N"
  @ 12,61 say "Add rate: " + str( BGE_Interval( "Addbooks"), 4, 2)
  @ 13,61 say "Del rate: " + str( BGE_Interval( "Killbooks"), 4, 2)
  devpos( row, col )  
  Return .T.

Function Showbooks()
  Local i
  Local col     := col()
  Local row     := row()

  devpos(14, 61)
  For i = 1 to Len( aBooks ) 
    @ 14+i, 61 say pad( aBooks[i], 13 )
  Next
 
  If row() < 20
    @ row()+1,61 clear to 20,74
  Endif

  Devpos( row, col )  
  Return .T.

Function Addbooks()
   Aadd( aBooks, time() )
   Return .T.

Function Killbooks()
  Static killrate := 0
  Local col     := col()
  Local row     := row()

  IF Len ( aBooks ) > 0
     aDel( aBooks, 1 )  
     aBooks := aSize( aBooks, Len(aBooks) - 1 )
  Endif


  If Killrate = 0
     Killrate := BGE_INterval( "Killbooks" )
       @ 13,61 say "Del rate: " + str( BGE_Interval( "Killbooks"), 4, 2)

  ElseIf Len( aBooks ) >= 5
     if Killrate != .2
       Deactivate event "addbooks"
       BGE_INterval( "Killbooks",, .2)
       @ 13,61 say "Del rate: " + str( BGE_Interval( "Killbooks"), 4, 2)
       Killrate :=      BGE_INterval( "Killbooks")
     Endif

  Elseif Len( aBooks ) < 2
     if Killrate != 2
       activate event "addbooks"
       BGE_INterval( "Killbooks",, 2)
       @ 13,61 say "Del rate: " + str( BGE_Interval( "Killbooks"), 4, 2)
       Killrate :=      BGE_INterval( "Killbooks")
     Endif
  Endif

  devpos( row, col )  
  Return NIL

  Function Stopdemo
     Eval( BGE_IDLEFUNC() )
     @ 0,0 clear
     @ 3,2 say "Demo Background Events v5.0 (Reentrant)" color "W+/N"
     @ 4,2 say "Versiondate: May 8, april 1997 " color "W/N"
 
     @ 6,2 say "By: Robert Franklin Lamping" Color "G/N"
     @ 7,2 say "Life Time Email: robert@winning.com" Color "G+/N"
     @ 9,2 say "This demo ended automaticly after 44 seconds using the following command:"
     @ 11,2 say "  Define BackGroundEvent Action STOPDEMO() Interval 44" color "B+/N"
     @ 14,0
     quit
     Return Nil


Function StartTyping
  Static lCleared := .T.
  local col := col()
  Local row := row()
//  Local oEvent := clevent():hasname( "Typing")
  Local nEventPos := bge_pos( "Typing" )

  If DSeconds() - BGE_TIMER( , nEventpos ) > 4
    BGE_ResetTimer(, nEventpos)
    @ 0,0 
    lCleared := .T.
  Elseif nextkey() != 0
    BGE_ResetTimer(, nEventpos)
    @ 0,0 
    lCleared := .T.

  Elseif DSeconds() - BGE_TIMER( , nEventpos ) > 3 .and. nextkey() = 0
    lCleared := .F.
    @ 0,0 say "Please type something..."

  Endif
  DevPos( row, col )

  Return nil
  
Function clock( nNum , cColor) 
  local col := col()
  Local row := row()
  Default cColor to "B/W"
  @ Maxrow() - 3- nNum, 2 say "Clock" + " " + str(nNum,2) + " " + str(seconds()*100,9) ;
                       Color cColor
  
  DevPos( row, col )

  Return Nil

Function LapWhiten( ) 
  local col := col()
  Local row := row()
  @ 14,30 say replicate("",25 )
  DevPos( row, col )
  Return ( .T. )

Function Laptimer( ) 
  local col := col()
  Local row := row()
  Local nSeconds :=  bge_seconds("LAPTIMER" )

  @ 14,30 say "Laptimer : " + str( Dseconds()-nSeconds,8,0)

  DevPos( row, col )

  Return Nil

Function showstopdemo( ) 
  local col := col()
  Local row := row()
  Local nSeconds :=  bge_seconds( "SHOWSTOP")

  @ 0,57 say "Demo duration : " + str( ( dseconds()-nSeconds),2,0) + "/44"

  DevPos( row, col )

  Return Nil

Function whiten( nNum) 
  Local col := col()
  Local row := row()
  @ Maxrow() - nNum -4, 2 say replicate("",20 )
  DevPos( row, col )
  Return ( .T. )

FuncTion ActTimer
  @ 3,48, 6,77 box "Ŀ "
  @ 3,50 say "BarTimer" color "W+/N"
  Return .T.

FuncTion ActTimer2
  @ 8,47, 11,77 box "Ŀ "
  Return .T.

Function Timer( nNum) 
  local col := col()
  Local row := row()
  Local nEventPos := bge_pos( "Timer" )
  Local nLastTime :=  bge_seconds( , nEventpos )
  Local nSeconds  := dseconds()
  Static lDisplayed:= .F.
  
  @ 4,49 say Pad( Replicate( "", nSeconds - nLasttime), 10 )

  if nSeconds - nLasttime > 10
    BGE_resettimer( ,nEventpos )
    @ 5,49 say "10 seconds further"
    lDisplayed := .T.
  elseif nSeconds - nLasttime > 2
    if lDisplayed 
        lDisplayed := .F.
        Acttimer()
    Endif
  
  Endif

  DevPos( row, col ) 
  Return Nil

Function Timer2( nNum) 
  local col := col()
  Local row := row()
  Local nEventPos := bge_pos( "Timer" )
  Local nLastTime :=  bge_seconds( , nEventpos )
  Local nSeconds  := dseconds()
  Static lDisplayed:= .F.
  
  @ 9,49 say Pad( Replicate( "", nSeconds - nLasttime), 10 )

  if nSeconds - nLasttime > 10
    BGE_resettimer( ,nEventpos )
    @ 10,49 say "Er zijn weer 10 seconden om"
    lDisplayed := .T.
  elseif nSeconds - nLasttime > 2
    if lDisplayed 
        lDisplayed := .F.
        Acttimer()
    Endif
  
  Endif

  DevPos( row, col ) 
  Return Nil

Function maydisp
  Return right( Str( Int( seconds() ),15, 0 ),1 ) $ "1 5"

Function maydisp2
  Local nSec := Val( right(str(Int( seconds() )),1) )
  Return .T. //nSec > 0 .and. nSec < 6

Function getme(nNum)
  Local cTekst := space(20)
  Local getlist[0]
  Local nKey, bKey
  Local cKlok := "KLOK" + ltrim(str(nNum,4,0))
  Default nNum to 0
  @ 24-nNum, 2 say Pad("Clock " + ltrim(str(nNum)) + " disabled. Press F12 or another key",50)
  set key K_F12 to getmenow
  DEACTIVATE EVENT cKlok
  do while .T.
     nKey := inkey()
     If ! Empty( bKey := SETKEY( NkEY))
       @ 24-nNum, 2 say Pad("Clock " + ltrim(str(nNum)) + " disabled. Loosing focus",50)
       Eval( bKey )
       Exit
     elseif nKey != 0
        Exit
     endif
 
  enddo
  ACTIVATE EVENT  cKlok
  @ 24-nNum, 2 say Replicate( "", 50)
//  set key K_F10 to clearline
  Return nil

Function getmenow
  Local cTekst := space(20)
  Local getlist[0]
  Local cScreen := savescreen( 8+9,40-18, 10+9,75-18)
  Local nEventPos := bge_pos( "Getme" )
  bge_stall( , nEventpos )
  ACTIVATE EVENT "LAPTIMER"

  set key K_F12 to
  @ 24,0 
  @ 8+9, 40-18 clear to 10+9, 75-18
  @ 8+9, 40-18 to 10+9, 75-18
  @ 9+9,41-18 say "Second field" get cTekst
  read
  restscreen(  8+9,40-18, 10+9,75-18, cScreen )

  bge_event( , nEventpos )[BGE_NSECONDS] := seconds() 

  DEACTIVATE EVENT "LAPTIMER"
  bge_resume( , nEventpos )

  Return  nil

Function KillClock( xEvent )
  DEACTIVATE EVENT xEvent
  Return .T.

FUNCTION DISPRE()
  /*
  * Display reentrance level
  */
  @ 8,53 say "Reentrance level : " color "G+/N"
  @ row(), col() say str( BGE_RELEVEL(),2) color "G/N"
  Return .T.

function scrsaver
   * Here I need a function which returns how long ago a key event or 
   * mouse events has taken place.
   * The source here below is an attempt, but doesn't work correctly.

   Static nSeconds := Nil
   If ! Valtype( nSeconds ) == "N"
      nSeconds := dseconds()
   Endif

   if nextkey() != 0
      nSeconds := dseconds()
      @ 24,0 
   Endif
   if DSeconds() - nSeconds > 4
      @ 24,0 say "Screensaver on"
   Endif
   //   @ 24,60 say LTRIM(STR(MEMORY(104)))   // Idle Conv.
   Return .T.


Function DIRECTTONE()
   tone(1000,1)
   tone(100,1)
   release event "directtone"
   Return .T.

